# Practical Assignments for Network Science

This repository contains practical assignments on network analysis. All assignments are presented as Jupyter notebooks, that can be done by writing code instead of the line 
```
# YOUR CODE HERE
```
All notebooks contain test cells with `assert` statements that help you understand whether your code is correct.

Topics:
1. [Introduction to Network Science](assignment_intro/assignment.ipynb)
2. [Power Law and Scale-free Networks](assignment_power_law/assignment.ipynb)
3. [Random Networks](assignment_random_networks/assignment.ipynb)
4. [Generative Network Models](assignment_generative_network_models/assignment.ipynb)
5. [Centrality Measures](assignment_centrality_measures/assignment.ipynb)
6. [Links Analysis and Structure](assignment_link_structure/assignment.ipynb)
7. [Community Detection](assignment_communities/assignment.ipynb)
8. [Community Detection, part 2](assignment_communities_2/assignment.ipynb)
9. [Compartmental Epidemic Models](assignment_compartmental_epidemics/assignment.ipynb)
10. [Epidemics on Graphs](assignment_epidemics_on_graphs/assignment.ipynb)
11. [Node Classification](assignment_node_classification/assignment.ipynb)
12. [Link Prediction](assignment_link_prediction/assignment.ipynb)
13. [Node Embedding](assignment_node_embedding/assignment.ipynb)
14. [Graph Neural Networks](assignment_graph_neural_networks/assignment.ipynb)
15. [Influence Propagation](assignment_influence_agents/assignment.ipynb)
16. [Knowledge Graph Embedding](assignment_knowledge_graph_embeddings/assignment.ipynb)
17. [Multihop Reasoning in Knowledge Graphs](assignment_multihop/assignment.ipynb)

Here are also descriptions of some competitions held among students to solve practical tasks on graphs:
1. [Network Generation](competition_network_generation/competition.ipynb)
2. [Link Prediction](competition_link_prediction/competition.ipynb)
3. [Marketing Campaign](competition_marketing_campaign/competition.ipynb)

Lecture materials: http://leonidzhukov.net/hse/2021/networkscience/

Youtube channel with records of lectures: https://youtube.com/playlist?list=PLriUvS7IljvkGesFRuYjqRz4lKgodJgh2
